Subject: Quote arguments in system command on Windows
Description

The bootstrap currently does not quote system call arguments on Windows. This leads to errors if the path to your php binary contains
spaces.

$command = 'SET FLOW3_ROOTPATH=' . FLOW3_PATH_ROOT . '&' . 'SET FLOW3_CONTEXT=' . $this->context . '&' .
$this->settings['core']['phpBinaryPathAndFilename'] . ' -c ' . php_ini_loaded_file() . ' ' . FLOW3_PATH_FLOW3 . 'Scripts/flow3' .
' ' . escapeshellarg($commandIdentifier);

Should be changed to:

$command = 'SET FLOW3_ROOTPATH="' . FLOW3_PATH_ROOT . '"&' . 'SET FLOW3_CONTEXT="' . $this->context . '"&"' .
$this->settings['core']['phpBinaryPathAndFilename'] . '" -c "' . php_ini_loaded_file() . '" "' . FLOW3_PATH_FLOW3 .
'Scripts/flow3' . ' ' . escapeshellarg($commandIdentifier) . '"';

TODO: Test

Related issues:
related to TYPO3.Flow - Bug # 31779: Command execution on Windows breaks with... Closed 2011-11-12

Associated revisions
Revision 7bb24f9d - 2011-07-19 17:36 - Bastian Waidelich

[BUGFIX] Properly escape and quote CLI arguments

Currently arguments that are passed to the system() function in
Bootstrap::executeCommand() are not properly escaped.
This leads to errors if arguments / paths contain spaces.

Change-Id: Ief9eb0e1800cd9810867e607ba66456dcbb3ee4e
Resolves: #27995

History
#1 - 2011-07-09 17:07 - Adrian Föder

we should also consider changing the REM in the new flow3.bat file from

REM This can include the php.ini to be used (for example "SET PHP=C:/php/php.exe -c C:/php/php.ini")
to some kind of

REM This can include the php.ini to be used (for example SET PHP="C:/php/php.exe" -c "C:/php/php.ini"    )

So we should directly write the double quotes even if they are not necessary in the example; but to avoid errors when user rely on that suggestion.

#2 - 2011-07-11 13:21 - Mr. Hudson
- Status changed from New to Under Review

Patch set 1 of change Ief9eb0e1800cd9810867e607ba66456dcbb3ee4e has been pushed to the review server.
It is available at http://review.typo3.org/3243

#3 - 2011-07-19 17:37 - Mr. Hudson

Patch set 2 of change Ief9eb0e1800cd9810867e607ba66456dcbb3ee4e has been pushed to the review server.
It is available at http://review.typo3.org/3243

#4 - 2011-07-19 18:05 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:7bb24f9dc49324d2ed931d641b7dbe6ffe6934f7.
